<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" label-width="68px">
      <el-form-item label="厂商账号" prop="appId">
        <el-input
          v-model="queryParams.appId"
          placeholder="请输入厂商账号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="签名" prop="signName">
        <el-input
          v-model="queryParams.signName"
          placeholder="请输入签名"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['setting:sms:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['setting:sms:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['setting:sms:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['setting:sms:export']"
        >导出</el-button>
      </el-col>
    </el-row>

    <el-table
      v-loading="loading"
      :data="smsList"
      :default-sort="{prop: 'createTime', order: 'descending'}"
      @sort-change="sortChange"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="主键ID" align="center" prop="id" /> -->
      <el-table-column label="序号" type="index" align="center" width="50" />
      <el-table-column label="厂商类型" align="center" sortable="custom" prop="appType">
        <template slot-scope="scope">
          <span>{{dictValueToLabel(scope.row.appType, manufacturerOptions)}}</span>
        </template>
      </el-table-column>
      <el-table-column label="区域ID" align="center" sortable="custom" prop="regionId" />
      <el-table-column label="厂商账号" align="center" sortable="custom" prop="appId" />
      <el-table-column label="签名" align="center" prop="signName" />
      <el-table-column label="创建时间" align="left" sortable="custom" prop="createTime" width="160">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime, "{y}-{m}-{d} {h}:{i}:{s}") }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['setting:sms:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['setting:sms:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改短信厂商对话框 -->
    <el-dialog class="form-dialog" :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="厂商类型">
          <el-select v-model="form.appType" placeholder="请选择厂商类型">
            <el-option
              v-for="dict in manufacturerOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="区域ID" prop="regionId">
          <el-input v-model="form.regionId" placeholder="请输入区域ID" />
        </el-form-item>
        <el-form-item label="厂商账号" prop="appId">
          <el-input v-model="form.appId" placeholder="请输入厂商账号" />
        </el-form-item>
        <el-form-item label="厂商密码" prop="appSecret">
          <el-input v-model="form.appSecret" type="passWord" placeholder="请输入厂商密码" />
        </el-form-item>
        <el-form-item label="签名" prop="signName">
          <el-input v-model="form.signName" placeholder="请输入签名" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listSms, getSms, delSms, addSms, updateSms } from "@/api/setting/sms";
import { dictValueToLabel } from "@/utils/hciot";

export default {
  name: "SmsFirm",
  props: {
    tenantId: {
      type: Number,
      default: null
    }
  },
  data() {
    return {
      // 厂商类型 字典
      manufacturerOptions: [],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 短信厂商表格数据
      smsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        appId: undefined,
        signName: undefined,
        orderByColumn: "createTime",
        isAsc: "desc"
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        appType: [
          { required: true, message: "请选择厂商类型", trigger: "blur" }
        ],
        regionId: [
          { required: true, message: "区域ID不能为空", trigger: "blur" }
        ],
        appId: [
          { required: true, message: "厂商账号不能为空", trigger: "blur" }
        ],
        appSecret: [
          { required: true, message: "厂商密码不能为空", trigger: "blur" }
        ],
        signName: [{ required: true, message: "签名不能为空", trigger: "blur" }]
      }
    };
  },
  created() {
    this.getList();
    this.init();
  },
  methods: {
    sortChange(column) {
      const sort = {
        isAsc: column.order === "descending" ? "desc" : "asc",
        orderByColumn: column.prop
      };
      this.queryParams = Object.assign(this.queryParams, sort);
      this.handleQuery();
    },
    dictValueToLabel,
    // 默认初始化 方法
    init() {
      this.getDicts("sys_manufacturer_type").then(response => {
        this.manufacturerOptions = response.data;
      });
    },
    /** 查询短信厂商列表 */
    getList() {
      this.loading = true;
      listSms(
        Object.assign(
          {
            tenantId: this.tenantId
          },
          this.queryParams
        )
      ).then(response => {
        this.smsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        appType: undefined,
        regionId: undefined,
        appId: undefined,
        appSecret: undefined,
        signName: undefined,
        tenantId: this.tenantId
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
      this.single = selection.length != 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加短信厂商";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getSms(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改短信厂商";
      });
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != undefined) {
            updateSms(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              }
            });
          } else {
            addSms(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm(
        // '是否确认删除短信厂商编号为"' + ids + '"的数据项?',
        "是否删除该数据",
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }
      )
        .then(function() {
          return delSms(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "setting/sms/export",
        {
          ...this.queryParams
        },
        `setting_sms.xlsx`
      );
    }
  }
};
</script>
